//Graphics Aggregates

#ifndef AGGREGATE_PLUSPLUS_H
#define AGGREGATE_PLUSPLUS_H

  #if BUILDNG_AGGREGATE_PLUSPLUS_H
    #define AGGREGATE_IMPEXP_TYPED __declspec(dllexport)
  #else
    #define AGGREGATE_IMPEXP_TYPED __declspec(dllimport)
  #endif

#include <List.h>
#include "Primitive++.h"
  
class AGGREGATE_IMPEXP_TYPED aggregatef:public BList, primitivef
{
  public:
    aggregatef();
    aggregatef(aggregatef *);
    aggregatef(aggregatef *, int);
    aggregatef(BMessage *, primitivef *other(BMessage *) = NULL);
  
    virtual void transform(basisf);
    virtual void translate(vectorf);
    virtual void draw();
    
    static BArchivable *Instantiate(BMessage *);
    virtual status_t Archive(BMessage *, bool) const;

    aggregatef* operator +(aggregatef);
    bool operator <<(primitivef *);
};

#endif